﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Linq;

namespace DbSharp.Framework.CaseFile.Parser
{

    /// <summary>
    /// Parse DefaultResultsetOutputSetting object from case file
    /// </summary>
    public class DefaultRsOutputSettingParser
    {
        #region Private members

        private XElement m_XGlobalSettingElement = null;

        private DefaultRsOutputSetting m_Setting = new DefaultRsOutputSetting();

        #endregion


        public DefaultRsOutputSettingParser(XElement globalSettingElement)
        {
            m_XGlobalSettingElement = globalSettingElement;
            Extract();
        }


        #region Private methods

        private void Extract()
        {
            OutputSettingAttrParser.OverrideSetting(m_Setting, m_XGlobalSettingElement);
        }

        #endregion


        #region Public properties/methods

        public DefaultRsOutputSetting Setting
        {
            get { return m_Setting; }
        }

        #endregion

    }
}
