﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using DbSharp.Utils.ComputerDetect;
using DbSharp.Utils.RegCode;
using DbSharp.SupportLib.Crypto;
using System.Xml.Linq;
using System.IO;
using DbSharp.Utils.IO;

namespace DbSharp.Framework.ReleaseManage
{

    public interface ILicenseAuth
    {
        string RegisterCode { get; set; }
        string ActivationCode { get; set; }
        bool Authenticate();
        void RetrieveLicenseData();
    }


 
    class NullLicenseAuth : ILicenseAuth
    {
        #region ILicenseAuth Members

        public string RegisterCode { get; set; }
        public string ActivationCode { get; set; }


        public bool Authenticate()
        {
            return true;
        }
        
 
        public void RetrieveLicenseData()
        {
            RegisterCode = string.Empty;
            ActivationCode = string.Empty;         
        }

        #endregion
    }

 
}
