﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using DbSharp.ConsoleRunner.Parser;


namespace DbSharp.ConsoleRunner
{
    [ArgumentGroupCertification("u,p", EArgumentGroupCondition.OneOreNoneUsed)]
    class Options
    {
        [SwitchArgument('h', "help", false, Description = "Show this help")]
        public bool ShowHelp;
        [SwitchArgument('u', "unittest", false, Description = "Run unit test only")]
        public bool UnitTest;
        [SwitchArgument('p', "performancetest", false, Description = "Run performance test only")]
        public bool PerformanceTest;
        [SwitchArgument('s', "silent", false, Description = "Silent mode")]
        public bool Silent;
        [ValueArgument(typeof(string), 't', "tag", Description = "Run case by tag", AllowMultiple = true)]
        public List<string> Tags = new List<string>();
        [ValueArgument(typeof(string), 'c', "case", Description = "Run case by name", AllowMultiple = true)]
        public List<string> CaseNames = new List<string>();
        [ValueArgument(typeof(string), 'l', "log", Description = "Log file name")]
        public string Log;
        [SwitchArgument('x', "export", false, Description = "Export xml file")]
        public bool Export;
    }
}
