﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DbSharp.ConsoleRunner.Parser
{
    public abstract class ArgumentCertification
    {
        /// <summary>
        /// Test the parser for the certification. This method should throw an exception if the condition
        /// is not met. 
        /// </summary>
        /// <param name="parser">parser object gives access to the defined arguments, their values and 
        /// parameters of the parser</param>
        public abstract void Certify(CommandLineParser parser);

        /// <summary>
        /// Returns description of the certification.
        /// </summary>
        public virtual string GetDescription
        {
            get { return this.ToString(); }
        }
    }
}
