﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DbSharp.ConsoleRunner.Parser
{
    public class SwitchArgumentAttribute : ArgumentAttribute
    {
        /// <summary>
        /// Creates new instance of SwitchArgumentAtribute.
        /// </summary>
        /// <param name="shortName"><see cref="Argument.ShortName">short name</see> of the underlying argument</param>
        /// <param name="defaultValue"><see cref="SwitchArgument.DefaultValue">default value</see> of the underlying argument</param>
        public SwitchArgumentAttribute(char shortName, bool defaultValue)
            : base(typeof(SwitchArgument), shortName, defaultValue)
        {
        }

        /// <summary>
        /// Creates new instance of SwitchArgumentAtribute.
        /// </summary>
        /// <param name="shortName"><see cref="Argument.ShortName">short name</see> of the underlying argument</param>
        /// <param name="longName"><see cref="Argument.LongName">long name</see> of the underlying argument</param>
        /// <param name="defaultValue"><see cref="SwitchArgument.DefaultValue">default value</see> of the underlying argument</param>
        public SwitchArgumentAttribute(char shortName, string longName, bool defaultValue)
            : base(typeof(SwitchArgument), shortName, longName, defaultValue)
        {
        }
    }
}
