﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using DbSharp.Framework.TestEngine;
using System.Windows.Forms;

namespace DbSharp.GuiRunner.View
{
    
    class GuiTestReportNotifier : ITestReportNotify
    {
        private RichTextBox m_OutputTextbox;

        public GuiTestReportNotifier(RichTextBox outputTextbox)
        {
            m_OutputTextbox = outputTextbox;
        }

        #region ITestReportNotify Members

        public void UpdateStatus(TestReport summary)
        {
            string outputText = summary.ToString();
            if (string.IsNullOrEmpty(outputText) == false)
            {
                m_OutputTextbox.AppendText(outputText);
                m_OutputTextbox.AppendText(Environment.NewLine);
            }
        }

        #endregion
    }
}
