﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DbSharp.Tools.DbConnectionBuilder.Core
{
    class FileVersionPair
    {
        public string DisplayVersion { get; set; }
        public string PropertyVersion { get; set; }

        public override string ToString()
        {
            if (string.IsNullOrEmpty(DisplayVersion))
                return string.Empty;
            else
                return DisplayVersion.ToString();
        }
    }

    class DbServerCredential
    {
        public string DataSource { get; set; }
        public string ServerPort { get; set; }
        public string Database { get; set; }
        public string UserId { get; set; }
        public string Password { get; set; }
        public bool OsInteAuth { get; set; }
        public FileVersionPair DbFileVersion { get; set; }
        public string AdditionalInfo { get; set; }
        public List<FileVersionPair> ListCandidateDbFileVersionPair = new List<FileVersionPair>();

        public bool DataSourceEnabled { get; set; }
        public bool ServerPortEnabled { get; set; }
        public bool DatabaseEnabled { get; set; }
        public bool UserIdEnabled { get; set; }
        public bool PasswordEnabled { get; set; }
        public bool OsInteAuthEnabled { get; set; }
        public bool DbFileVersionEnabled { get; set; }
        public bool DbFileVersionMust { get; set; }
    }


}
